package eu.eudat.models.data.datarepository;

import com.fasterxml.jackson.annotation.JsonProperty;
import eu.eudat.data.entities.DataRepository;
import eu.eudat.data.entities.UserInfo;
import eu.eudat.models.DataModel;

import java.util.Date;
import java.util.UUID;

/**
 * Created by ikalyvas on 9/3/2018.
 */
public class DataRepositoryModel implements DataModel<DataRepository, DataRepositoryModel> {
    private UUID id;
    @JsonProperty("name")
    private String label;
    private String abbreviation;
    private String uri;
    private Date created;
    private Date modified;
    private String tag;

    public UUID getId() {
        return id;
    }
    public void setId(UUID id) {
        this.id = id;
    }

    public String getLabel() {
        return label;
    }
    public void setLabel(String label) {
        this.label = label;
    }

    public String getAbbreviation() {
        return abbreviation;
    }
    public void setAbbreviation(String abbreviation) {
        this.abbreviation = abbreviation;
    }

    public String getUri() {
        return uri;
    }
    public void setUri(String uri) {
        this.uri = uri;
    }

    public Date getCreated() {
        return created;
    }
    public void setCreated(Date created) {
        this.created = created;
    }

    public Date getModified() {
        return modified;
    }
    public void setModified(Date modified) {
        this.modified = modified;
    }

    public String getTag() {
        return tag;
    }
    public void setTag(String tag) {
        this.tag = tag;
    }

    @Override
    public DataRepositoryModel fromDataModel(DataRepository entity) {
        this.setAbbreviation(entity.getAbbreviation());
        this.setLabel(entity.getLabel());
        this.setUri(entity.getUri());
        this.setId(entity.getId());
        this.tag = "Internal";
        return this;
    }

    @Override
    public DataRepository toDataModel() throws Exception {
        DataRepository dataRepository = new DataRepository();
        dataRepository.setId(this.id != null ? this.id : UUID.randomUUID());
        dataRepository.setAbbreviation(this.abbreviation);
        dataRepository.setCreated(this.created != null ? this.created : new Date());
        dataRepository.setModified(new Date());
        dataRepository.setLabel(this.label);
        dataRepository.setReference("dmpdata/" + dataRepository.getId());
        dataRepository.setUri(this.uri);
        dataRepository.setStatus((short) 0);
        dataRepository.setCreationUser(new UserInfo());
        return dataRepository;
    }

    @Override
    public String getHint() {
        return null;
    }
}
