package eu.eudat.models.data.rda;

import eu.eudat.data.entities.DMP;
import eu.eudat.data.entities.Dataset;

import java.util.LinkedList;
import java.util.List;

public class RDAExportModel {
    private DmpRDAExportModel dmp;
    private List<DatasetRDAExportModel> datasets;

    public DmpRDAExportModel getDmp() {
        return dmp;
    }
    public void setDmp(DmpRDAExportModel dmp) {
        this.dmp = dmp;
    }

    public List<DatasetRDAExportModel> getDatasets() {
        return datasets;
    }
    public void setDatasets(List<DatasetRDAExportModel> datasets) {
        this.datasets = datasets;
    }

    public RDAExportModel fromDataModel(DMP dmp) {
        this.dmp = new DmpRDAExportModel().fromDataModel(dmp);
        this.datasets = new LinkedList<>();
        for (Dataset dataset : dmp.getDataset()) {
            this.datasets.add(new DatasetRDAExportModel().fromDataModel(dataset));
        }
        return this;
    }
}
